// gomuks - A terminal Matrix client written in Go.
// Copyright (C) 2019 Tulir Asokan
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

package html

import (
	"maunium.net/go/mauview"
	"maunium.net/go/tcell"
)

type CodeBlockEntity struct {
	*BaseEntity
	Background tcell.Style
}

func NewCodeBlockEntity(children []Entity, background tcell.Style) *CodeBlockEntity {
	return &CodeBlockEntity{
		BaseEntity: &BaseEntity{
			Tag:      "pre",
			Block:    true,
			Children: children,
		},
		Background: background,
	}
}

func (ce *CodeBlockEntity) Draw(screen mauview.Screen) {
	screen.Fill(' ', ce.Background)
	ce.BaseEntity.Draw(screen)
}

func (ce *CodeBlockEntity) AdjustStyle(fn AdjustStyleFunc) Entity {
	// Don't allow adjusting code block style.
	return ce
}
